org.apache.xmlgraphics.image.loader.spi

## Interface ImageConverter

- All Known Implementing Classes:
    AbstractImageConverter, ImageConverterBitmap2G2D, ImageConverterBuffered2Rendered, ImageConverterG2D2Bitmap, ImageConverterRendered2PNG

      public interface ImageConverter

  Defines an image converter that can convert one image representation into another.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `MEDIUM_CONVERSION_PENALTY` Default/Medium conversion penalty (if there's some effort to convert the image format)
    `static int` | `MINIMAL_CONVERSION_PENALTY` Used if the conversion penalty is minimal
    `static int` | `NO_CONVERSION_PENALTY` Used if the conversion penalty is negligible (for example a simple cast).

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `Image` | `convert(Image src, java.util.Map<java.lang.String,java.lang.Object> hints)` Converts an image into a different representation.
    `int` | `getConversionPenalty()` Returns the conversion penalty for the conversion that this implementation supports.
    `ImageFlavor` | `getSourceFlavor()` Returns the flavor that this converter expects.
    `ImageFlavor` | `getTargetFlavor()` Returns the flavor that this converter converts images into.

- - ### Field Detail

    - #### NO_CONVERSION_PENALTY

          static final int NO_CONVERSION_PENALTY

      Used if the conversion penalty is negligible (for example a simple cast).
      See Also:
        Constant Field Values

    - #### MINIMAL_CONVERSION_PENALTY

          static final int MINIMAL_CONVERSION_PENALTY

      Used if the conversion penalty is minimal
      See Also:
        Constant Field Values

    - #### MEDIUM_CONVERSION_PENALTY

          static final int MEDIUM_CONVERSION_PENALTY

      Default/Medium conversion penalty (if there's some effort to convert the image format)
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### convert

          Image convert(Image src,
                        java.util.Map<java.lang.String,java.lang.Object> hints)
                 throws ImageException,
                        java.io.IOException

      Converts an image into a different representation.

      Consumers can get the effective MIME type (if any) from the associated `ImageFlavor`.

      Parameters:
        `src` - the source image
        `hints` - the conversion hints
      Returns:
        the converted image
      Throws:
        `ImageException` - if an error occurs while converting the image
        `java.io.IOException` - if an I/O error occurs while converting the image

    - #### getTargetFlavor

          ImageFlavor getTargetFlavor()

      Returns the flavor that this converter converts images into.
      Returns:
        the target flavor

    - #### getSourceFlavor

          ImageFlavor getSourceFlavor()

      Returns the flavor that this converter expects.
      Returns:
        the source flavor

    - #### getConversionPenalty

          int getConversionPenalty()

      Returns the conversion penalty for the conversion that this implementation supports.
      Returns:
        the conversion penalty (must be a non-negative integer)

Copyright 1999-2025 The Apache Software Foundation. All Rights Reserved.